﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Acies.Creatures;
using Acies.Creatures.Temporary_Effects;
using Acies.Announcements;


namespace Acies.Items.Use_Strategies
{
    public class ApplyTemporaryEffect : IUseStrategy 
    {
        private ITemporaryEffect _effect;

        public ApplyTemporaryEffect(ITemporaryEffect effect)
        {
            _effect = effect;
        }

        public void Use(IItem item, World world, ICreature user)
        {
            Announcer.Instance.Announce(user.Name + " feels different. ", MessageTypes.Other);
            Announcer.Instance.Announce(user.Name + " is under the affect of " + _effect.Name + "!", MessageTypes.Other);
            user.AddTemporaryEffect(_effect);
            user.Inventory.Remove(item);
        }
    }
}
